;************************************************************************
;*									*
;*			Analog Comparator interrupt			*
;*	Save slave clock status into EEPROM in the case of power fail	*
;*									*
;*		Author: Christian Koch					*
;*			christian_koch@gmx.de				*
;*									*
;* Usage of the works is permitted provided that this			*
;* instrument is retained with the works, so that any entity		*
;* that uses the works is notified of this instrument.			*
;*									*
;* DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.				*
;*									*
;* [2004, Fair License; rhid.com/fair]					*
;*									*
;************************************************************************
;
;used: a0
;interrupts already deactivated because we are in an ISR
;
	ldi	a0, 1<<led_error^1<<led_recv^1<<led_valid^1<<led_a^1<<led_b
	out	led_port, a0		;switch off all leds

	clr	a0
	out	EEAR, a0
	out	EEDR, slvhour
	sbi	EECR, EEMWE
	sbi	EECR, EEWE

acint1:
	sbic	EECR, EEWE		;write complete?
	rjmp	acint1

	inc	a0
	out	EEAR, a0
	out	EEDR, slvminute
	sbi	EECR, EEMWE
	sbi	EECR, EEWE

acint2:
	sbic	EECR, EEWE		;write complete?
	rjmp	acint2

acint3:
	ldi	timeout, 100			;wait 100 * 10 ms
acint4:
	ldi	a0, 1 + xtal * 100 / 2560000	;wait 10 ms
	rcall	_wait256
	dec	timeout
	brne	acint4

	sbic	ACSR, ACO		;in the case supply stabilizes
	rjmp	acint3

	rjmp	init			;reboot
;------------------------------------------------------------------------
