;************************************************************************
;*									*
;*				DCF77 LCD Clock				*
;*									*
;*			Author: P. Dannegger				*
;*				danni@specs.de				*
;*			Author: C. Koch					*
;*				christian_koch@gmx.de			*
;*									*
;************************************************************************
.nolist
.include "clock.h"
.include "lcd.mac"
.list
.listmac
	rjmp	init
;-------------------------------------------------------------------------
.org	ovf0addr
	rjmp ovf0int
.org	aciaddr
.include "acint.inc"
.include "ovf0int.inc"
;-------------------------------------------------------------------------
init:
	ldi	a0, RAMEND			;initialize stack pointer
	out	SP, a0

	ldi	timeout, 100			;wait 100 * 10 ms
init1:
	ldi	a0, 1 + xtal * 100 / 2560000	;wait 10 ms
	rcall	_wait256
	dec	timeout
	brne	init1

	clr	a0
	out	DDRA, a0			;whole port A as input
	out	DDRB, a0			;whole port B as input

	ser	a0
	out	PORTA, a0			;pull up whole port A
	out	PORTB, a0			;pull up whole port B

	ldi	a0, 1<<CS01^1<<CS00
	out	TCCR0, a0			;prescaler 1/64
	ldi	a0, 1<<TOIE0
	out	TIMSK, a0			;enable timer interrupt

	rcall	lcd_init

	rcall	master_clock_init

	ldi	a0, reload1sec
	mov	reload, a0
	ldi	a0, 59
	mov	delta, a0

	ldi	second, 0
	ldi	minute, 0
	ldi	hour, 0
	ldi	weekday, 1
	ldi	day, 1
	ldi	month, 1
	ldi	year, 1

	sei
;-------------------------------------------------------------------------
main:
display_clock_ret:
	rcall	decodedcf77
	rcall	master_clock			;service master clock
	brts	_mai1				;display new time
	sbrs	flags, second1
	rjmp	main
	rcall	clock_inc			;count time
_mai1:						
;beware that we can run through this block twice a second if DCF second
;is received after RTC second
	cbr	flags, 1<<second1

	sbi	led_port, led_error		;status leds
	sbrc	flags, dcf77error		;DCF77 Status
	cbi	led_port, led_error
	sbi	led_port, led_recv
	sbrs	newsecond, 0			;blink 1/2 Hz
	cbi	led_port, led_recv

	rjmp	display_clock_inline
;-------------------------------------------------------------------------
.include "lcd12s.inc"
.include "clockd.inc"
.include "dcf77.inc"
.include "div60.inc"
.include "mstclk.inc"
;------------------------------------------------------------------------
;initial slave clock status
.eseg
.db	0, 0
;------------------------------------------------------------------------
