;*************************************************************************
.include "tn26def.inc"
;-------------------------------------------------------------------------
;				Constant definitions
;-------------------------------------------------------------------------
.equ	xtal		= 1000000	;1MHz

.equ	reload1sec	= (xtal / 64 + 128 ) / 256
;-------------------------------------------------------------------------
;				Using register
;-------------------------------------------------------------------------
.def	SaveSreg	= r1		;for interrupt usage

.def	c0			= r2
.def	c1			= r3

.def	slvminute	= r4		;slave clock status
.def	slvhour		= r5

.def	reload		= r7
.def	delta		= r8
.def	prescaler	= r9

.equ	addrnewminute 	= 10
.def	newminute 	= r10
.def	newhour 	= r11
.def	newday 		= r12
.def	newweekday 	= r13
.def	newmonth 	= r14
.def	newyear 	= r15
;-------------------------------------------------------------------------
.def	second		= r16		;actual time
.def	minute		= r17
.def	hour		= r18
.def	day			= r19
.def	weekday		= r20
.def	month		= r21
.def	year		= r22

.def	Flags 		= r23
.equ	Dcf77value	= 0			;must be 0 !
.equ	Dcf77pulse	= 1			;must be 1 !
.equ	Dcf77Input	= 2
.equ	dcf77sync	= 3
.equ	Dcf77Parity = 4
.equ	Dcf77Error 	= 5
.equ	second1		= 6			;1 second gone

.def	dcf77time	= r24
.def	sum			= r25

.def	newsecond 	= r26		;new time

.def	timeout		= r27

.def	a0		= r28			;arithmetic operands
.def	a1		= r29
.def	z0		= r30			;z pointer
.def	z1		= r31
;-------------------------------------------------------------------------
;				Port definitions
;-------------------------------------------------------------------------
.equ	lcd_ddr			= DDRB
.equ	lcd_port		= PORTB
.equ	lcd_e			= PORTB3
.equ	lcd_rs			= PORTB4
.equ	lcd_ck			= PORTB0

.equ	dcf77_pin		= PINA
.equ	dcf77_data		= PINA1		;DCF77 data input

.equ	led_ddr			= DDRA
.equ	led_port		= PORTA
.equ	led_valid		= PORTA2	;status led
.equ	led_recv		= PORTA3	;status led
.equ	led_error		= PORTA4	;status led
.equ	led_a			= PORTA5	;opto-isolator led
.equ	led_b			= PORTA6	;opto-isolator led

.equ	switch_ddr		= DDRB
.equ	switch_port		= PORTB
.equ	switch_pin		= PINB
.equ	switch_wait		= PINB5	;control switch for master clock
.equ	switch_forward	= PINB6	;control switch for master clock
;-------------------------------------------------------------------------
