;************************************************************************/
;*									*/
;*			Clock / Calendar				*/
;*                                                                      */
;*              Author: Peter Dannegger                                 */
;*                      danni@specs.de                                  */
;*                                                                      */
;************************************************************************/
;used:	a0, a1, r0, z0
;stack:	2 !
;
display_clock_inline:				;inline !
	lcd_pos	0x00				;line 1
	mov	a0, hour
	rcall	dec_out2
	ldi	a0, ':'
	rcall	lcd_data
	mov	a0, minute
	rcall	dec_out2
	ldi	a0, ':'
	rcall	lcd_data
	mov	a0, second
	rcall	dec_out2

	lcd_pos	0x10				;line 2
	mov	a0, day
	rcall	dec_out2
	ldi	a0, '.'
	rcall	lcd_data
	mov	a0, month
	rcall	dec_out2
	ldi	a0, '.'
	rcall	lcd_data
	ldi	a0, '2'
	rcall	lcd_data
	ldi	a0, '0'
	rcall	lcd_data
	mov	a0, year
	rcall	dec_out2

	lcd_pos	0x1E				;DCF77 Status
	ldi	a0, ' '
	sbrc	flags, dcf77error
	ldi	a0, 'E'
	rcall	lcd_data
	ldi	a0, ' '
	sbrs	newsecond, 0
	ldi	a0, '*'
	rcall	lcd_data
	rjmp	Display_clock_ret
;-------------------------------------------------------------------------
;stack:	2 !
;
dec_out2:
	mov	z0, a0
	ldi	a0, '0' - 1
_dou2:	inc	a0
	subi	z0, 10
	brcc	_dou2
	rcall	lcd_data

	mov	a0, z0
	subi	a0, -'0' - 10
	rjmp	lcd_data
;-------------------------------------------------------------------------
;stack:	1
;
clock_inc:
	inc	second
	cpi	second, 60
	brcs	_clo3
	ldi	second, 0
	inc	minute
	cpi	minute, 60
	brcs	_clo3
	ldi	minute, 0
	inc	hour
	cpi	hour, 24
	brcs	_clo3
	ldi	hour, 0
	inc	day
	inc	weekday
	cpi	weekday, 8
	brcs	_clo1
	ldi	weekday, 1
_clo1:	ldi	a0, 30			;30 days
	cpi	month, 4
	breq	_clo2
	cpi	month, 6
	breq	_clo2
	cpi	month, 9
	breq	_clo2
	cpi	month, 11
	breq	_clo2
	ldi	a0, 31			;31 days
	cpi	month, 2
	brne	_clo2
	ldi	a0, 29			;29 days = leap year
	sbrs	year, 0
	sbrc	year, 1
	ldi	a0, 28			;28 days
_clo2:	cp	a0, day
	brcc	_clo3
	ldi	day, 1
	inc	month
	cpi	month, 13
	brcs	_clo3
	ldi	month, 1
	inc	year
	cpi	year, 100
	brcs	_clo3
	ldi	year, 0
_clo3:	ret
;-------------------------------------------------------------------------
