;************************************************************************
;*									*
;*			Timer 0 interrupt				*
;*			Timebase, DCF77 receive				*
;*									*
;************************************************************************

.equ	minpulse	= reload1sec * 5 / 100		;50ms
.equ	pulselowhigh	= reload1sec * 15 / 100		;150ms
.equ	maxpulse	= reload1sec * 25 / 100		;250ms

.equ	min1sec		= reload1sec * 90 / 100		;0.9s
.equ	max1sec		= reload1sec * 110 / 100	;1.1s

.equ	min2sec		= reload1sec * 180 / 100	;1.8s
.equ	max2sec		= reload1sec * 220 / 100	;2.2s
;-------------------------------------------------------------------------
ovf0int:
	in	savesreg, sreg

	inc	c0				;pulses per minute
	brne	_tov1
	inc	c1
_tov1:
	dec	prescaler			;count down prescaler
	brne	_tov3
	sbr	flags, 1<<second1
	mov	prescaler, reload		;reload prescaler
	add	sum, delta
	brcc	_tov3
	subi	sum, 60
	inc	prescaler			;fine adjustment
_tov3:
	cpi	dcf77time, 1
	sbci	dcf77time, -1			;count: 1,2...fe,ff,00,00

	bst	flags, dcf77input

;change to sbic in the case the DCF signal is inverted
	sbis	dcf77_pin, dcf77_data		;DCF77 input pin
	rjmp	_tov5
	brtc	_tov8
	cbr	flags, 1<<dcf77input		;0->1 transition

	subi	dcf77time, minpulse
	cpi	dcf77time, maxpulse - minpulse
	brcs	_tov4
	sbr	flags, 1<<dcf77error		; error
_tov4:	cpi	dcf77time, pulselowhigh - minpulse	;pulse length
	sbci	flags, -3
	subi	dcf77time, -minpulse
	rjmp	_tov8

_tov5:	brts	_tov8
	sbr	flags, 1<<dcf77input		;1->0 transition

	subi	dcf77time, min1sec
	cpi	dcf77time, max1sec - min1sec
	brcs	_tov7				; 1 second

	subi	dcf77time, min2sec - min1sec
	cpi	dcf77time, max2sec - min2sec
	brcs	_tov6
	sbr	flags, 1<<dcf77error		; error
_tov6:	sbr	flags, 1<<dcf77sync		; 2 second
_tov7:	ldi	dcf77time, 1

_tov8:	tst	timeout
	breq	_tov9
	dec	timeout
_tov9:	out	sreg, savesreg
	reti
;------------------------------------------------------------------------
